Traffic Flow Tiles API

The Traffic Flow Tile API offers current traffic speed data for map display, allowing for either absolute or relative speed information. This includes current speed, free-flow speed, and a quality indicator. It can illustrate both real-time traffic speeds on road segments and the deviation from free-flow speeds on those same segments.

The service delivers traffic flow data in vector tiles, which are squared sections represented in a vector format.

  • Each tile includes a pre-defined collection of road shapes with traffic flow data.
  • The format of the tile is formally described using the protobuf schema.

The data is mapped to a protobuf layer called "Traffic flow". Besides the protobuf layers, the protobuf tags are also used to further describe the traffic. The protobuf tags are split into two categories: default and on-demand.

  1. The default tags are used unless they are filtered out by the tags request parameter.
  2. The on-demand tags are used only if they were added by the tags request parameter.
  3. Read more about these tags and valid values here.

Following is the endpoint to retrieve the traffic flow tile information:

GET

https://api.nextbillion.io/orbis/traffic/tile/flow/{z}/{x}/{y}.{format}?key={Your_API_Key}&apiVersion=1

Path Parameters

NameRequiredFormat & UsageDescription
zYesType: integer

Minimum Value: 0 Maximum Value: 22
Zoom level of the tile to be rendered. The values should be in the range of [0,22].
xYesType: integer

Maximum Value: 2z-1
Specify the x-coordinate of the tile or the tile’s column on the zoom grid z. The maximum value should be less than 2z.
yYesType: integer

Maximum Value: 2z-1
Specify the y-coordinate of the tile or the tile’s row on the zoom grid z. The maximum value should be less than 2z.
formatYesType: string

Allowed Values: pbf
The format of the response.

Request Parameters

NameRequiredFormat & UsageDescription
keyYesType: string

Format: 32 character alphanumeric string Example: key=API_KEY
A key is a unique identifier that is required to authenticate a request to the API.
roadCategoryFilterNoType: string

Default Value: all road categories

Allowed Values: motorway, motorway_link, trunk, trunk_link, primary, primary_link, secondary, secondary_link, tertiary, tertiary_link, street, service, track
This filter allows the choice of types of road categories to be included in the response. The filter narrows down the road categories available at particular zoom level. Multiple values are supported and should be separated by a comma.
tagsNo

Type: array

Format: [tags_1, tags_2, …]

Default value: icon_category, left_hand_traffic, magnitude_of_delay, road_category, road_subcategory

The list of the values representing the available tags in the tile:

  • icon_category (enables icon_category_[idx]) - magnitude_of_delay
  • left_hand_traffic
  • road_category
  • road_subcategory
  • description(enables description_[idx])
  • delay part_of_two_way_road
  • start_time
  • end_time
  • id -
  • probability_of_occurence
  • number_of_reports
  • last_report_time
  • average_speed_kmph
  • openlr
  • time_validity
  • display_class

By default, only the default tags are attached to the tile geometry. See Vector format for details.

  • The list of the values must be enclosed in square brackets [ ], and each value must be separated by a comma.
  • The fewer tags chosen, the smaller the tile size because of better geometry merging. -
  • Only tags that are used in both of the two protobuf layers can be used as a parameter value.
  • the array of parameters is empty, only the tags unique for the particular layer are sent.
apiVersionNoType: integer
Allowed Values: 1
Specify the version of the API service to be called. The current value is 1.

Sample Request

1
curl --location 'https://api.nextbillion.io/orbis/traffic/tile/flow/12/2929/1898.pbf?apiVersion=1&key=<your_api_key>'

API Query Limits

  • NextBillion.ai allows a maximum rate limit of 6000 queries per minute or 100 queries/second for continuous requests.
    Note: We can increase the quota if needed, on request. Contact support@nextbillion.ai for more details.

API Error Codes

Response codeDescriptionAdditional notes
200Normal success case.Normal success case.
400Input validation failed.There is a missing or an invalid parameter or a parameter with an invalid value type is added to the request.
401APIKEY not supplied or invalidThis error occurs when the wrong API key is passed in the request or the key is missing altogether.
403APIKEY is valid but does not have access to requested resourcesYou might be querying for a geographical region which is not valid for your account or requesting a service which is not enabled for you.
404Requested host/path not foundThis error occurs when a malformed hostname is used.
422Could not process the requestA feasible solution could not be generated for the given set of locations or parameter configuration.
429Too many requestsQPM reached or API request count quota reached.
500Internal Service error.There was an internal issue with NextBillion.ai services. You can reach out to support@nextbillion.ai for an explanation.